﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;//.Tasks;
using System.Windows.Forms;
using GcDevicePc.GCBuffer;

namespace GcDevicePc.ConfigMethod
{
    public partial class FID : Form
    {

        HWConfig hwconfig;
        GCMethodConfig methodconfig;


        public FID(HWConfig hwconfig, ref GCMethodConfig methodconfig)
        {
            InitializeComponent();

            this.hwconfig = hwconfig;
            this.methodconfig = methodconfig;
        }

        public FID()
        {
            InitializeComponent();

        }

        int configTemp;

        public void reflashContent(int index)
        {

            this.methodconfig.GetFidByID(index);

            switch (index)
            {
                case 0:
                    configTemp = globaldata.m_hwconfig.hwconfiginfo.u16DetFrontPTemp;
                    break;
                case 1:
                    configTemp = globaldata.m_hwconfig.hwconfiginfo.u16DetInterPTemp;
                    break;
                case 2:
                    configTemp = globaldata.m_hwconfig.hwconfiginfo.u16DetBehindPTemp;
                    break;
                default:
                    break;
            }

            fidsettemp.Text = this.methodconfig.fid[index].fHeaterTempSet.ToString();
            if (hwconfig.hwconfiginfo.u16StartType == 1 || hwconfig.hwconfiginfo.u16StartType == 3)
            {
                tb氢气压力设定.Text = this.methodconfig.fid[index].fSetH2Flow.ToString();
                tb空气压力设定.Text = this.methodconfig.fid[index].fAirFlowSet.ToString();
                tb尾吹气压力设定.Text = this.methodconfig.fid[index].fSetTailGas.ToString();

                if (this.methodconfig.fid[index].u16KeyH2Flow == 1)
                    cBox氢气.CheckState = CheckState.Checked;
                else
                    cBox氢气.CheckState = CheckState.Unchecked;

                if (this.methodconfig.fid[index].u16KeyAirFlow == 1)
                    cBox空气.CheckState = CheckState.Checked;
                else
                    cBox空气.CheckState = CheckState.Unchecked;

                if (this.methodconfig.fid[index].u16KeyTailGas == 1)
                    cBox尾吹气.CheckState = CheckState.Checked;
                else
                    cBox尾吹气.CheckState = CheckState.Unchecked;
            }
            else
            {
                tb氢气压力设定.Enabled = false;
                tb空气压力设定.Enabled = false;
                tb尾吹气压力设定.Enabled = false;

                cBox氢气.Enabled = false;
                cBox空气.Enabled = false;
                cBox尾吹气.Enabled = false;
            }
            

            cb灵敏度.SelectedIndex = this.methodconfig.fid[index].u16Sensitive;
            cb极性.SelectedIndex = this.methodconfig.fid[index].u16Polarity;

            if (this.methodconfig.fid[index].u16KeyFire == 1)
                cBox自动点火.CheckState = CheckState.Checked;
            else
                cBox自动点火.CheckState = CheckState.Unchecked;

            if (this.methodconfig.fid[index].u16Zero == 1)
                cBox自动调零.CheckState = CheckState.Checked;
            else
                cBox自动调零.CheckState = CheckState.Unchecked;

            //if (this.methodconfig.fid[index].u16KeyHeater == 1)
            //    cBox加热器.CheckState = CheckState.Checked;
            //else
            //    cBox加热器.CheckState = CheckState.Unchecked;



            if (this.methodconfig.fid[index].u16SigDeduct < 3 && this.methodconfig.fid[index].u16SigDeduct >= 0)
                cListBoxSign.SetItemChecked(this.methodconfig.fid[index].u16SigDeduct, true);
        }
        private void TextBoxDec_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar != 8 && !Char.IsDigit(e.KeyChar) && e.KeyChar != '.')
            {
                e.Handled = true;
            }
        }
        float string2float(string s)
        {
            float ret;

            if(string.IsNullOrEmpty(s))
            {
                ret = 0;
            }
            else
            {
                ret = float.Parse(s);
            }

            return ret;
        }
        public void recordCurData(int index)
        {
            this.methodconfig.fid[index].fHeaterTempSet = string2float(fidsettemp.Text);
            this.methodconfig.fid[index].fSetH2Flow = string2float(tb氢气压力设定.Text);
            this.methodconfig.fid[index].fAirFlowSet = string2float(tb空气压力设定.Text);
            this.methodconfig.fid[index].fSetTailGas = string2float(tb尾吹气压力设定.Text);
            this.methodconfig.fid[index].u16Sensitive = (ushort)cb灵敏度.SelectedIndex;
            this.methodconfig.fid[index].u16Polarity = (ushort)cb极性.SelectedIndex;

            if (cBox自动点火.CheckState == CheckState.Checked)
                this.methodconfig.fid[index].u16KeyFire = 1;
            else
                this.methodconfig.fid[index].u16KeyFire = 0;

            if (cBox自动调零.CheckState == CheckState.Checked)
                this.methodconfig.fid[index].u16Zero = 1;
            else
                this.methodconfig.fid[index].u16Zero = 0;

            //if (cBox加热器.CheckState == CheckState.Checked)
            this.methodconfig.fid[index].u16KeyHeater = 1;
            //else
            //    this.methodconfig.fid[index].u16KeyHeater = 0;

            if (cBox氢气.CheckState == CheckState.Checked)
                this.methodconfig.fid[index].u16KeyH2Flow = 1;
            else
                this.methodconfig.fid[index].u16KeyH2Flow = 0;

            if (cBox空气.CheckState == CheckState.Checked)
                this.methodconfig.fid[index].u16KeyAirFlow = 1;
            else
                this.methodconfig.fid[index].u16KeyAirFlow = 0;

            if (cBox尾吹气.CheckState == CheckState.Checked)
                this.methodconfig.fid[index].u16KeyTailGas = 1;
            else
                this.methodconfig.fid[index].u16KeyTailGas = 0;

            if (cListBoxSign.GetItemChecked(0) == true)
                this.methodconfig.fid[index].u16SigDeduct = 1;
            else if (cListBoxSign.GetItemChecked(1) == true)
                this.methodconfig.fid[index].u16SigDeduct = 2;
            else if (cListBoxSign.GetItemChecked(2) == true)
                this.methodconfig.fid[index].u16SigDeduct = 3;

            this.methodconfig.epc[0].fristFlow = string2float(tb尾吹气压力设定.Text);
            this.methodconfig.epc[0].gasType1 = (ushort)0;
            this.methodconfig.epc[0].SecondFlow = string2float(tb氢气压力设定.Text);
            this.methodconfig.epc[0].gasType2 = (ushort)0;
            this.methodconfig.epc[0].ThirdFlow = string2float(tb空气压力设定.Text);
            this.methodconfig.epc[0].gasType3 = (ushort)0;
        }
        bool isone = false;
        private double hlastnum;
        private void hText_KeyDown(object sender, KeyEventArgs e)
        {
            if (!string.IsNullOrEmpty((sender as TextBox).Text))
            {
                hlastnum = Convert.ToDouble((sender as TextBox).Text);
            }
            else
            {
                hlastnum = 0;
            }
        }
        private void hText_KeyUp(object sender, KeyEventArgs e)
        {
            if (!string.IsNullOrEmpty((sender as TextBox).Text))
            {
                double nextnum = Convert.ToDouble((sender as TextBox).Text);
                if (nextnum < 5)
                {
                    MessageBox.Show("流量设置不能小于5");
                    (sender as TextBox).Text = hlastnum.ToString();
                }
                if (nextnum > 200)
                {
                    MessageBox.Show("流量设置不能大于200");
                    (sender as TextBox).Text = hlastnum.ToString();
                }
            }
        }
        private void vInput_Limit_TextChange(object sender, EventArgs e)
        {
            double usData;
            double dMaxInpueValue = 120;
            double dMinInputValue = 0;
            byte   bRetainBit = 2;
            TextBox DeTextBox = (TextBox)sender;
            if (DeTextBox.Equals(txtyuzhi))
            {
                bRetainBit = 3;
                dMinInputValue = -1000;
                dMaxInpueValue = 1000;
            }
            else if (DeTextBox.Equals(fidsettemp))
            {
                bRetainBit = 2;
                dMinInputValue = 0;
                dMaxInpueValue = globaldata.m_hwconfig.hwconfiginfo.u16DetFrontPTemp;
            }
            else if (DeTextBox.Equals(tb氢气压力设定) || DeTextBox.Equals(tb尾吹气压力设定))
            {
                bRetainBit = 2;
                dMinInputValue = 0;
                dMaxInpueValue = 120;
            }
            else if(DeTextBox.Equals(tb空气压力设定))
            {
                bRetainBit = 2;
                dMinInputValue = 0;
                dMaxInpueValue = 500;
            }
            if (double.TryParse(DeTextBox.Text, out usData)) //|| valve_1_start1.Text.IndexOf(".") == valve_1_start1.Text.Length)
            {
                if (usData > dMaxInpueValue)
                {
                    ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(dMaxInpueValue.ToString());
                }
                else if(usData < dMinInputValue)
                {
                    ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(dMinInputValue.ToString());
                }
                else if(DeTextBox.Text.StartsWith("0") == true && DeTextBox.Text.IndexOf(".") != 1 || (DeTextBox.Text.IndexOf(".") > -1 && DeTextBox.Text.Length - DeTextBox.Text.IndexOf(".") > (bRetainBit + 1) && DeTextBox.Text.EndsWith("0") == true))
                {
                    DeTextBox.Clear();
                    DeTextBox.AppendText(usData.ToString());
                }
                else if(DeTextBox.Text.Length == (DeTextBox.Text.IndexOf(".") + 1))
                {

                }
                else if (DeTextBox.Text.IndexOf(".") > -1 && DeTextBox.Text.Length - DeTextBox.Text.IndexOf(".") > (bRetainBit + 1))
                {
                    ToolTip1.Show($"精确小数点后{bRetainBit}位",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(usData.ToString().Substring(0,usData.ToString().Length -1));
                }
            }
            else if(dMinInputValue < 0 && DeTextBox.Text == "-")
            {

            }
            else  if(DeTextBox.Text != "" && DeTextBox.Text.Length != 0)
            {
                string str = DeTextBox.Text;
                ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                DeTextBox.Clear();
                DeTextBox.AppendText(str.Substring(0,str.Length -1));
            }

        }
        private void vInput_Limit_MouseLeave(object sender, EventArgs e)
        {
            TextBox DeTextBox = (TextBox)sender;          
            //if(DeTextBox.Text == "")
            //{
            //    DeTextBox.Text = "0";
            //}
            ToolTip1.Show("",DeTextBox,3000);
        }

    }
}
