﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using GcDevicePc.GCBuffer;
using GcDevicePc.IniParam;

namespace GcDevicePc.ConfigMethod
{
    public partial class SignalTab : Form
    {
        HWConfig hwconfig;
        GCMethodConfig methodconfig;

        public SignalTab(HWConfig hwconfig, ref GCMethodConfig methodconfig)
        {
            InitializeComponent();

            this.hwconfig = hwconfig;
            this.methodconfig = methodconfig;
        }

        private void updatecombobox()
        {
            cleanALLItem();
            addALLItem("无");
            //if (this.hwconfig.hwconfiginfo.u16DetFront == 1)
            {
                if (this.hwconfig.hwconfiginfo.u16DetFrontType == 0)  //TCD
                {
                    addALLItem("TCD(前)");
                }
                else if (this.hwconfig.hwconfiginfo.u16DetFrontType == 1) //FID
                {
                    addALLItem("FID(前)");
                }
            }


            //if (this.hwconfig.hwconfiginfo.u16DetInter == 1)
            {
                if (this.hwconfig.hwconfiginfo.u16DetInterType == 0)  //TCD
                {
                    addALLItem("TCD(中)");
                }
                else if (this.hwconfig.hwconfiginfo.u16DetInterType == 1)  //FID
                {
                    addALLItem("FID(中)");
                }
            }


            //if (this.hwconfig.hwconfiginfo.u16DetBehind == 1)
            {
                if (this.hwconfig.hwconfiginfo.u16DetBehindType == 0)  //TCD
                {
                    addALLItem("TCD(后)");
                }
                else if (this.hwconfig.hwconfiginfo.u16DetBehindType == 1) // FID
                {
                    addALLItem("FID(后)");
                }
            }
        }

        public void reflashContent()
        {
            const int MAX_NUM = 8;
            int channel = 0;
            ComboBox tmpcombox;
            TextBox tmptextbox;
            int i = 0;
            //float time;

            this.methodconfig.GetDevSignalAllPara();
            updatecombobox();

            signalA_sw.CheckState = this.methodconfig.signal.u16ChannelA == 1 ? CheckState.Checked : CheckState.Unchecked;
            signalB_sw.CheckState = this.methodconfig.signal.u16ChannelB == 1 ? CheckState.Checked : CheckState.Unchecked;


            for (i = 0; i < MAX_NUM; i++)
            {
                channel = i + 1;
                tmpcombox = this.Controls.Find("signal_A_" + channel.ToString(), true)[0] as ComboBox;
                tmptextbox = (TextBox)(this.Controls.Find("signalAT" + channel.ToString(), true)[0]);

                tmpcombox.SelectedIndex = (int)this.methodconfig.signal.uDetA[i];
                if (this.methodconfig.signal.u16DetTimeLengthA[i] > 0)
                {
                    tmptextbox.Text = ((float)this.methodconfig.signal.u16DetTimeLengthA[i] / 60).ToString("#0.0");
                }
            }

            for (i = 0; i < MAX_NUM; i++)
            {
                channel = i + 1;
                tmpcombox = (ComboBox)(this.Controls.Find("signal_B_" + channel.ToString(), true)[0]);
                tmptextbox = (TextBox)(this.Controls.Find("signalBT" + channel.ToString(), true)[0]);

                tmpcombox.SelectedIndex = (int)this.methodconfig.signal.uDetB[i];
                if (this.methodconfig.signal.u16DetTimeLengthB[i] > 0)
                {
                    tmptextbox.Text = ((float)this.methodconfig.signal.u16DetTimeLengthB[i] / 60).ToString("#0.0");
                }
            }
        }

        private void cleanALLItem()
        {
            const int MAX_NUM = 8;
            int channel = 0;
            ComboBox tmpcombox;
            int i = 0;
            for (i = 0; i < MAX_NUM; i++)
            {
                channel = i + 1;
                tmpcombox = (ComboBox)(this.Controls.Find("signal_A_" + channel.ToString(), true)[0]);
                tmpcombox.Items.Clear();
            }

            for (i = 0; i < MAX_NUM; i++)
            {
                channel = i + 1;
                tmpcombox = (ComboBox)(this.Controls.Find("signal_B_" + channel.ToString(), true)[0]);
                tmpcombox.Items.Clear();
            }
        }

        private void addALLItem(string name)
        {
            const int MAX_NUM = 8;
            int channel = 0;
            ComboBox tmpcombox;
            int i = 0;
            for (i = 0; i < MAX_NUM; i++)
            {
                channel = i + 1;
                tmpcombox = (ComboBox)(this.Controls.Find("signal_A_" + channel.ToString(), true)[0]);
                tmpcombox.Items.Add(name);
            }

            for (i = 0; i < MAX_NUM; i++)
            {
                channel = i + 1;
                tmpcombox = (ComboBox)(this.Controls.Find("signal_B_" + channel.ToString(), true)[0]);
                tmpcombox.Items.Add(name);
            }
        }

        private void SignalDlg_Load(object sender, EventArgs e)
        {
            cleanALLItem();
            addALLItem("无");
            if (this.hwconfig.hwconfiginfo.u16DetFront == 1)
            {
                if (this.hwconfig.hwconfiginfo.u16DetFrontType == 0)  //TCD
                {
                    addALLItem("TCD(前)");
                }
                else if (this.hwconfig.hwconfiginfo.u16DetFrontType == 1) //FID
                {
                    addALLItem("FID(前)");
                }
            }


            if (this.hwconfig.hwconfiginfo.u16DetInter == 1)
            {
                if (this.hwconfig.hwconfiginfo.u16DetInterType == 0)  //TCD
                {
                    addALLItem("TCD(中)");
                }
                else if (this.hwconfig.hwconfiginfo.u16DetInterType == 1)  //FID
                {
                    addALLItem("FID(中)");
                }
            }


            if (this.hwconfig.hwconfiginfo.u16DetBehind == 1)
            {
                if (this.hwconfig.hwconfiginfo.u16DetBehindType == 0)  //TCD
                {
                    addALLItem("TCD(后)");
                }
                else if (this.hwconfig.hwconfiginfo.u16DetBehindType == 1) // FID
                {
                    addALLItem("FID(后)");
                }
            }

        }

        private void vInput_Limit_TextChange(object sender, EventArgs e)
        {
            double usData;
            double dMaxInpueValue = 1080;
            double dMinInputValue = 0;
            byte   bRetainBit = 2;
            TextBox DeTextBox = (TextBox)sender;

            if (double.TryParse(DeTextBox.Text, out usData)) //|| valve_1_start1.Text.IndexOf(".") == valve_1_start1.Text.Length)
            {
                if (usData > dMaxInpueValue)
                {
                    ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(dMaxInpueValue.ToString());
                }
                else if(usData < dMinInputValue)
                {
                    ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(dMinInputValue.ToString());
                }
                else if(DeTextBox.Text.StartsWith("0") == true && DeTextBox.Text.IndexOf(".") != 1 || (DeTextBox.Text.IndexOf(".") > -1 && DeTextBox.Text.Length - DeTextBox.Text.IndexOf(".") > (bRetainBit + 1) && DeTextBox.Text.EndsWith("0") == true))
                {
                    DeTextBox.Clear();
                    DeTextBox.AppendText(usData.ToString());
                }
                else if(DeTextBox.Text.Length == (DeTextBox.Text.IndexOf(".") + 1))
                {

                }
                else if (DeTextBox.Text.IndexOf(".") > -1 && DeTextBox.Text.Length - DeTextBox.Text.IndexOf(".") > (bRetainBit + 1))
                {
                    ToolTip1.Show($"精确小数点后{bRetainBit}位",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(usData.ToString().Substring(0,usData.ToString().Length -1));
                }
            }
            else if(dMinInputValue < 0 && DeTextBox.Text == "-")
            {

            }
            else  if(DeTextBox.Text != "" && DeTextBox.Text.Length != 0)
            {
                string str = DeTextBox.Text;
                ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                DeTextBox.Clear();
                DeTextBox.AppendText(str.Substring(0,str.Length -1));
            }

        }

        private void vInput_Limit_MouseLeave(object sender, EventArgs e)
        {
            TextBox DeTextBox = (TextBox)sender;          
            //if(DeTextBox.Text == "")
            //{
            //    DeTextBox.Text = "0";
            //}
            ToolTip1.Show("",DeTextBox,3000);
        }
        private void TextBoxDec_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (!(((e.KeyChar >= '0') && (e.KeyChar <= '9')) || e.KeyChar <= 31))
            {
                if (e.KeyChar == '.')
                {
                    if (((TextBox)sender).Text.Trim().IndexOf('.') > -1)
                        e.Handled = true;
                }
                else
                    e.Handled = true;
            }
            else
            {
                if (e.KeyChar <= 31)
                {
                    e.Handled = false;
                }
                else if (((TextBox)sender).Text.Trim().IndexOf('.') > -1)
                {
                    if (((TextBox)sender).Text.Trim().Substring(((TextBox)sender).Text.Trim().IndexOf('.') + 1).Length >= 4)
                        e.Handled = true;
                }
            }
          
        }

        public void recordCurData()
        {
            const int MAX_NUM = 8;
            int channel = 0;
            ComboBox tmpcombox;
            TextBox tmptextbox;
            int i = 0;
            float time;

            ushort newtime;

            this.methodconfig.signal.u16ChannelA = (signalA_sw.CheckState == CheckState.Checked) ? (ushort)1 : (ushort)0;
            this.methodconfig.signal.u16ChannelB = (signalB_sw.CheckState == CheckState.Checked) ? (ushort)1 : (ushort)0;

            CProfileDevice.m_DevParam.signal.u16ChannelA = (signalA_sw.CheckState == CheckState.Checked) ? (ushort)1 : (ushort)0;
            CProfileDevice.m_DevParam.signal.u16ChannelB = (signalB_sw.CheckState == CheckState.Checked) ? (ushort)1 : (ushort)0;


            for (i = 0; i < MAX_NUM; i++)
            {
                channel = i + 1;
                tmpcombox = (ComboBox)(this.Controls.Find("signal_A_" + channel.ToString(), true)[0]);
                tmptextbox = (TextBox)(this.Controls.Find("signalAT" + channel.ToString(), true)[0]);

                if (tmpcombox.SelectedIndex < 0)
                    this.methodconfig.signal.uDetA[i] = 0;
                else
                    this.methodconfig.signal.uDetA[i] = (ushort)tmpcombox.SelectedIndex;

                if (string.IsNullOrEmpty(tmptextbox.Text))
                {
                    this.methodconfig.signal.u16DetTimeLengthA[i] = 0;
                }
                else
                {
                    time = (float)Convert.ToDecimal(tmptextbox.Text);
                    newtime = (ushort)Convert.ToDecimal((time * 60).ToString());
                    this.methodconfig.signal.u16DetTimeLengthA[i] = newtime;

                }


                if (tmpcombox.SelectedIndex < 0)
                    CProfileDevice.m_DevParam.signal.uDetA[i] = 0;
                else
                    CProfileDevice.m_DevParam.signal.uDetA[i] = (ushort)tmpcombox.SelectedIndex;

                if (string.IsNullOrEmpty(tmptextbox.Text))
                {
                    CProfileDevice.m_DevParam.signal.u16DetTimeLengthA[i] = 0;
                }
                else
                {
                    time = (float)Convert.ToDecimal(tmptextbox.Text);
                    newtime = (ushort)Convert.ToDecimal((time * 60).ToString());
                    CProfileDevice.m_DevParam.signal.u16DetTimeLengthA[i] = newtime;

                }
            }

            for (i = 0; i < MAX_NUM; i++)
            {
                channel = i + 1;
                tmpcombox = (ComboBox)(this.Controls.Find("signal_B_" + channel.ToString(), true)[0]);
                tmptextbox = (TextBox)(this.Controls.Find("signalBT" + channel.ToString(), true)[0]);

                if (tmpcombox.SelectedIndex < 0)
                    this.methodconfig.signal.uDetB[i] = 0;
                else
                    this.methodconfig.signal.uDetB[i] = (ushort)tmpcombox.SelectedIndex;

                if (string.IsNullOrEmpty(tmptextbox.Text))
                {
                    this.methodconfig.signal.u16DetTimeLengthB[i] = 0;
                }
                else
                {
                    time = (float)Convert.ToDecimal(tmptextbox.Text);
                    newtime = (ushort)Convert.ToDecimal((time * 60).ToString());
                    this.methodconfig.signal.u16DetTimeLengthB[i] = newtime;
                }

                if (tmpcombox.SelectedIndex < 0)
                    CProfileDevice.m_DevParam.signal.uDetB[i] = 0;
                else
                    CProfileDevice.m_DevParam.signal.uDetB[i] = (ushort)tmpcombox.SelectedIndex;

                if (string.IsNullOrEmpty(tmptextbox.Text))
                {
                    CProfileDevice.m_DevParam.signal.u16DetTimeLengthB[i] = 0;
                }
                else
                {
                    time = (float)Convert.ToDecimal(tmptextbox.Text);
                    newtime = (ushort)Convert.ToDecimal((time * 60).ToString());
                    CProfileDevice.m_DevParam.signal.u16DetTimeLengthB[i] = newtime;
                }
            }

        }


    }
}
