﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using GcDevicePc.GCBuffer;


namespace GcDevicePc.ConfigMethod
{
    public partial class ValveTab : Form
    {
        HWConfig hwconfig;
        GCMethodConfig methodconfig;
        bool bNameTextBoxHasChange = false;
        public ValveTab(HWConfig hwconfig, ref GCMethodConfig methodconfig)
        {
            InitializeComponent();

            this.hwconfig = hwconfig;
            this.methodconfig = methodconfig;

            //foreach (Control control in this.Controls)
            //{
            //    if (control is GroupBox)
            //    {
            //       foreach (Control c in control.Controls)
            //       {
            //           if (c is TextBox)
            //           {
            //               c.Enabled = false;
            //           }

            //           if (c is CheckBox)
            //           {
            //               c.Enabled = false;
            //           }
            //       }
            //    }
            //}

            this.valvesw1.CheckedChanged += new EventHandler(valvesw_Changed);
            this.valvesw2.CheckedChanged += new EventHandler(valvesw_Changed);
            this.valvesw3.CheckedChanged += new EventHandler(valvesw_Changed);
            this.valvesw4.CheckedChanged += new EventHandler(valvesw_Changed);
            this.valvesw5.CheckedChanged += new EventHandler(valvesw_Changed);
            this.valvesw6.CheckedChanged += new EventHandler(valvesw_Changed);

        }
        private void vInput_Limit_TextChange(object sender, EventArgs e)
        {
            double usData;
            double dMaxInpueValue = 10000;
            double dMinInputValue = 0;
            byte   bRetainBit = 2;
            TextBox DeTextBox = (TextBox)sender;      
            if (double.TryParse(DeTextBox.Text, out usData)) //|| valve_1_start1.Text.IndexOf(".") == valve_1_start1.Text.Length)
            {
                if (usData > dMaxInpueValue)
                {
                    ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(dMaxInpueValue.ToString());
                }
                else if(usData < dMinInputValue)
                {
                    ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(dMinInputValue.ToString());
                }
                else if(DeTextBox.Text.StartsWith("0") == true && DeTextBox.Text.IndexOf(".") != 1 || (DeTextBox.Text.IndexOf(".") > -1 && DeTextBox.Text.Length - DeTextBox.Text.IndexOf(".") > (bRetainBit + 1) && DeTextBox.Text.EndsWith("0") == true))
                {
                    DeTextBox.Clear();
                    DeTextBox.AppendText(usData.ToString());
                }
                else if(DeTextBox.Text.Length == (DeTextBox.Text.IndexOf(".") + 1))
                {

                }
                else if (DeTextBox.Text.IndexOf(".") > -1 && DeTextBox.Text.Length - DeTextBox.Text.IndexOf(".") > (bRetainBit + 1))
                {
                    ToolTip1.Show($"精确小数点后{bRetainBit}位",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(usData.ToString().Substring(0,usData.ToString().Length -1));
                }
            }
            else if(dMinInputValue < 0 && DeTextBox.Text == "-")
            {

            }
            else  if(DeTextBox.Text != "" && DeTextBox.Text.Length != 0)
            {
                string str = DeTextBox.Text;
                ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                DeTextBox.Clear();
                DeTextBox.AppendText(str.Substring(0,str.Length -1));
            }

        }
        private void vInput_Limit_MouseLeave(object sender, EventArgs e)
        {
            TextBox DeTextBox = (TextBox)sender;          
            if(DeTextBox.Text == "")
            {
                DeTextBox.Text = "0";
            }
            ToolTip1.Show("",DeTextBox,3000);
        }

        private void vTextBox_Char_Limit_TextChange(object sender, EventArgs e)
        {
            byte ucCharMaxLength = 5;
            TextBox textBox =  (TextBox) sender;
            if(textBox.TextLength > ucCharMaxLength)
            {
                 string strData = textBox.Text;
                 textBox.Clear();
                 textBox.AppendText(strData.Substring(0,strData.ToString().Length -1));
                 ToolTip1.Show($"输入的字符长度大于{ucCharMaxLength}",textBox,3000);
            }
            if (textBox.Text != "" || textBox.Text != null)
            {
                textBox.Width = (textBox.TextLength + 1) * 11;
            }
        }  

        private void vName_Change_MouseLeave(object sender, EventArgs e)
        {
            bNameTextBoxHasChange = true;
        }
        private void ValveTab_Click(object sender, EventArgs e)
        {
            if(bNameTextBoxHasChange == true)
            {
                int channel;
                const int MAX_VALVE_NUM = 6;
                TextBox textBox;
                for (int i = 0; i < MAX_VALVE_NUM; i++)
                {
                    channel = i + 1;
                    textBox = (TextBox)(this.Controls.Find("NameTextBox" + channel.ToString(), true)[0]);     
                    if (textBox.Text == "")
                    {
                        textBox.Text = "阀";
                    }
                    textBox.BorderStyle = BorderStyle.None;
                    textBox.ReadOnly = true;
                }
            }
        }
        private void vNameTextBox_DoubleClick(object sender, EventArgs e)
        {
             TextBox textBox     = (TextBox)sender;
             textBox.ReadOnly    = false;
             textBox.BorderStyle = BorderStyle.FixedSingle;
        }
        public void enabletextboxonebyone(int id)
        {
            TextBox m_textbox;
            int channel = id;
            m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start1", true)[0]);
            m_textbox.Enabled = true;

            m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start2", true)[0]);
            m_textbox.Enabled = true;

            m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start3", true)[0]);
            m_textbox.Enabled = true;

            m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start4", true)[0]);
            m_textbox.Enabled = true;

            m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end1", true)[0]);
            m_textbox.Enabled = true;

            m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end2", true)[0]);
            m_textbox.Enabled = true;

            m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end3", true)[0]);
            m_textbox.Enabled = true;

            m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end4", true)[0]);
            m_textbox.Enabled = true;

        }

        /// <summary>
        /// 选中checkbox使能输入框，否则归零禁用
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void valvesw_Changed(object sender, EventArgs e)
        {
            CheckBox mycheckbox = (CheckBox)sender;
            int num = int.Parse(mycheckbox.Tag.ToString());

            if (mycheckbox.Checked)
            {
                enabletextboxonebyone(num);
            }


            if (this.valvesw1.Checked)
            {
                enabletextboxonebyone(1);
            }

            if (this.valvesw2.Checked)
            {
                enabletextboxonebyone(2);
            }


            if (this.valvesw3.Checked)
            {
                enabletextboxonebyone(3);
            }


            if (this.valvesw4.Checked)
            {
                enabletextboxonebyone(4);
            }


            if (this.valvesw5.Checked)
            {
                enabletextboxonebyone(5);
            }


            if (this.valvesw6.Checked)
            {
                enabletextboxonebyone(6);
            }

        }

        public void reflashContent()
        {
            this.methodconfig.valve[0].u16ValveSetTime1 = 213;

            const int MAX_VALVE_NUM = 6;
            CheckBox m_checkbox;
            TextBox m_textbox;
            int channel = 0;

            this.methodconfig.GetInjValveAllPara();

            this.Valvenum.Text = this.hwconfig.hwconfiginfo.u16ValveBox.ToString();

            try
            {
                for (int i = 0; i < MAX_VALVE_NUM; i++)
                {
                    channel = i + 1;
                    m_checkbox = (CheckBox)(this.Controls.Find("valvesw" + channel.ToString(), true)[0]);
                    m_checkbox.CheckState = this.methodconfig.valve[i].bHeaterKey ? CheckState.Checked : CheckState.Unchecked;

                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start1", true)[0]);
                    m_textbox.Text = (this.methodconfig.valve[i].u16ValveSetTime1 / 100.0f).ToString();
                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start2", true)[0]);
                    m_textbox.Text = (this.methodconfig.valve[i].u16ValveSetTime3 / 100.0f).ToString();
                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start3", true)[0]);
                    m_textbox.Text = (this.methodconfig.valve[i].u16ValveSetTime5 / 100.0f).ToString();
                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start4", true)[0]);
                    m_textbox.Text = (this.methodconfig.valve[i].u16ValveSetTime7 / 100.0f).ToString();
                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end1", true)[0]);
                    m_textbox.Text = (this.methodconfig.valve[i].u16ValveSetTime2 / 100.0f).ToString();
                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end2", true)[0]);
                    m_textbox.Text = (this.methodconfig.valve[i].u16ValveSetTime4 / 100.0f).ToString();
                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end3", true)[0]);
                    m_textbox.Text = (this.methodconfig.valve[i].u16ValveSetTime6 / 100.0f).ToString();
                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end4", true)[0]);
                    m_textbox.Text = (this.methodconfig.valve[i].u16ValveSetTime8 / 100.0f).ToString();

                    m_textbox = (TextBox)(this.Controls.Find("NameTextBox" + channel.ToString(), true)[0]);
                    m_textbox.Text = this.methodconfig.valve[i].strValveName;
                }
            }
            catch
            {

            }

            if (this.hwconfig.hwconfiginfo.u16ValveOne == 1)
            {
                this.groupBox1.Enabled = true;
                this.methodconfig.valve[0].bValveKey = true;
                this.NameTextBox1.Enabled = true;
            }
            else
            {
                this.groupBox1.Enabled = false;
                this.NameTextBox1.Enabled = false;
            }

            if (this.hwconfig.hwconfiginfo.u16ValveTwo == 1)
            {
                this.groupBox2.Enabled = true;
                this.methodconfig.valve[1].bValveKey = true;
                this.NameTextBox2.Enabled = true; 
            }
            else
            {
                this.groupBox2.Enabled = false;
                this.NameTextBox2.Enabled = false; 
            }

            if (this.hwconfig.hwconfiginfo.u16ValveThree == 1)
            {
                this.groupBox3.Enabled = true;
                this.methodconfig.valve[2].bValveKey = true;
                this.NameTextBox3.Enabled = true;
            }
            else
            {
                this.groupBox3.Enabled = false;
                this.NameTextBox3.Enabled = false;
            }

            if (this.hwconfig.hwconfiginfo.u16ValveFour == 1)
            {
                this.groupBox4.Enabled = true;
                this.methodconfig.valve[3].bValveKey = true;
                this.NameTextBox4.Enabled = true;
            }
            else
            {
                this.groupBox4.Enabled = false;
                this.NameTextBox4.Enabled = false;
            }

            if (this.hwconfig.hwconfiginfo.u16ValveFive == 1)
            {
                this.groupBox5.Enabled = true;
                this.methodconfig.valve[4].bValveKey = true;
                this.NameTextBox5.Enabled = true;
            }
            else
            {
                this.groupBox5.Enabled = false;
                this.NameTextBox5.Enabled = false;
            }

            if (this.hwconfig.hwconfiginfo.u16ValveSix == 1)
            {
                this.groupBox6.Enabled = true;
                this.methodconfig.valve[5].bValveKey = true;
            }
            else
            {
                this.groupBox6.Enabled = false;
            }
        }

        private void TextBoxDec_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (!(((e.KeyChar >= '0') && (e.KeyChar <= '9')) || e.KeyChar <= 31))
            {
                if (e.KeyChar == '.')
                {
                    if (((TextBox)sender).Text.Trim().IndexOf('.') > -1)
                        e.Handled = true;
                }
                else
                    e.Handled = true;
            }
            else
            {
                if (e.KeyChar <= 31)
                {
                    e.Handled = false;
                }
                else if (((TextBox)sender).Text.Trim().IndexOf('.') > -1)
                {
                    if (((TextBox)sender).Text.Trim().Substring(((TextBox)sender).Text.Trim().IndexOf('.') + 1).Length >= 4)
                        e.Handled = true;
                }
            }
        }

        public void recordCurData()
        {
            const int MAX_VALVE_NUM = 6;

            CheckBox m_checkbox;
            TextBox m_textbox;

            try
            {
                for (int i = 0; i < MAX_VALVE_NUM; i++)
                {
                    int channel = i + 1;
                    m_checkbox = (CheckBox)(this.Controls.Find("valvesw" + channel.ToString(), true)[0]);
                    this.methodconfig.valve[i].bHeaterKey = (m_checkbox.CheckState == CheckState.Checked) ? true : false;

                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start1", true)[0]);
                    if (m_textbox.Text != "")
                        this.methodconfig.valve[i].u16ValveSetTime1 = (ushort)(Convert.ToDecimal(m_textbox.Text) * 100);

                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start2", true)[0]);
                    if (m_textbox.Text != "")
                        this.methodconfig.valve[i].u16ValveSetTime3 = (ushort)(Convert.ToDecimal(m_textbox.Text) * 100);

                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start3", true)[0]);
                    if (m_textbox.Text != "")
                        this.methodconfig.valve[i].u16ValveSetTime5 = (ushort)(Convert.ToDecimal(m_textbox.Text) * 100);

                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_start4", true)[0]);
                    if (m_textbox.Text != "")
                        this.methodconfig.valve[i].u16ValveSetTime7 = (ushort)(Convert.ToDecimal(m_textbox.Text) * 100);

                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end1", true)[0]);
                    if (m_textbox.Text != "")
                        this.methodconfig.valve[i].u16ValveSetTime2 = (ushort)(Convert.ToDecimal(m_textbox.Text) * 100);

                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end2", true)[0]);
                    if (m_textbox.Text != "")
                        this.methodconfig.valve[i].u16ValveSetTime4 = (ushort)(Convert.ToDecimal(m_textbox.Text) * 100);

                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end3", true)[0]);
                    if (m_textbox.Text != "")
                        this.methodconfig.valve[i].u16ValveSetTime6 = (ushort)(Convert.ToDecimal(m_textbox.Text) * 100);

                    m_textbox = (TextBox)(this.Controls.Find("valve_" + channel.ToString() + "_end4", true)[0]);
                    if (m_textbox.Text != "")
                        this.methodconfig.valve[i].u16ValveSetTime8 = (ushort)(Convert.ToDecimal(m_textbox.Text) * 100);

                    m_textbox = (TextBox)(this.Controls.Find("NameTextBox" + channel.ToString(), true)[0]);
                    if (m_textbox.Text != "")
                        this.methodconfig.valve[i].strValveName = m_textbox.Text;
                }
            }
            catch
            {
                MessageBox.Show("阀数据出错！");
            }


        }

        private void InjValveDlg_Load(object sender, EventArgs e)
        {

        }


    }
}
