﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using GcDevicePc.GCBuffer;

namespace GcDevicePc.DeviceConfigUI
{
    public partial class ColumnBox : Form
    {
        #region 私有变量
        private HWConfig hWConfig;
        #endregion

        #region 构造函数
        public ColumnBox()
        {
            InitializeComponent();
        }

        public ColumnBox(ref HWConfig hwconfig)
        {
            InitializeComponent();
            this.hWConfig = hwconfig;
        }
        #endregion

        #region 窗口事件
        private void ColumnBox_Load(object sender, EventArgs e)
        {
            if (hWConfig != null)
            {
                this.Col.Checked = this.hWConfig.hwconfiginfo.u16Col == 1 ? true : false;
                this.ColType.SelectedIndex = this.hWConfig.hwconfiginfo.u16ColType;
                this.ColPTemp.Text = this.hWConfig.hwconfiginfo.u16ColPTemp.ToString();


            }

        }
        private void vInput_Limit_MouseLeave(object sender, EventArgs e)
        {
            TextBox DeTextBox = (TextBox)sender;          
            //if(DeTextBox.Text == "")
            //{
            //    DeTextBox.Text = "0";
            //}
            ToolTip1.Show("",DeTextBox,3000);
        }

        private void vInput_Integer_Limit_TextChange(object sender, EventArgs e)
        {
            TextBox TempTextBox = (TextBox)sender;
            ushort usData;
            ushort usMaxValue = 400;
            ushort usMinValue = 0;
            if(TempTextBox.Text.IndexOf(".") > -1)
            {
                string  strData = TempTextBox.Text;
                ToolTip1.Show("输入值为整数",TempTextBox,3000);
                TempTextBox.Clear();
                TempTextBox.AppendText(strData.Substring(0,strData.Length -1));
            }
            if (ushort.TryParse(TempTextBox.Text, out usData))
            {
                if (usData > usMaxValue)
                {
                    ToolTip1.Show($"输入值为{usMinValue}-{usMaxValue}的区间内",TempTextBox,3000);
                    TempTextBox.Clear();
                    TempTextBox.AppendText(usMaxValue.ToString());
                }
                else if(usData < usMinValue)
                {
                    ToolTip1.Show($"输入值为{usMinValue}-{usMaxValue}的区间内",TempTextBox,3000);
                    TempTextBox.Clear();
                    TempTextBox.AppendText(usMinValue.ToString());
                }
                else
                {
                    TempTextBox.Clear();
                    TempTextBox.AppendText(usData.ToString());
                }
            }
	        else if(usMinValue < 0 && TempTextBox.Text == "-")
            {

            }
            else  if(TempTextBox.Text != "" && TempTextBox.Text.Length != 0)
            {
                string str = TempTextBox.Text;
                ToolTip1.Show($"输入值为{usMinValue}-{usMaxValue}的区间内",TempTextBox,3000);
                TempTextBox.Clear();
                TempTextBox.AppendText(str.Substring(0,str.Length -1));
            }
        }
        #endregion


        #region 控件事件
        private void okbtn_Click(object sender, EventArgs e)
        {
            if (hWConfig != null)
            {

                this.hWConfig.hwconfiginfo.u16Col = this.Col.Checked ? 1:0;
                this.hWConfig.hwconfiginfo.u16ColType = this.ColType.SelectedIndex;
                this.hWConfig.hwconfiginfo.u16ColPTemp = int.Parse(this.ColPTemp.Text);

            }
            this.Close();
        }

        private void cancelbtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        #endregion
    }
}
