﻿using GcDevicePc.Common;
using Ini.Net;
using Microsoft.Win32;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;



namespace GcDevicePc
{
    public delegate void UpdataHMIOS(int index,ushort val);
    public delegate void UpdataHMIOpS(ushort val);
    public partial class SysConfig : Form
    {

        private string HmiIP = null;


        private ushort HmiPort = 911;
        private ArrayList SearchRet = new ArrayList();

        public SysConfig()
        {
            InitializeComponent();
        }
        public SysConfig(ushort[] val)
        {
            InitializeComponent();
            checkBox4.Checked = val[0] == 0 ? false : true;
            checkBox8.Checked = val[1] == 0 ? false : true;
            checkBox4.CheckedChanged += CheckBox4_CheckedChanged;
            checkBox8.CheckedChanged += CheckBox8_CheckedChanged1;

        }
        public event UpdataHMIOS uphos;

        public static bool   bIsAutoDisO2 = false;
        public static double kzhi = 1.00;
        public static double bzhi = 0.00;
        private void CheckBox8_CheckedChanged1(object sender, EventArgs e)
        {
           
            ushort val = checkBox8.Checked ? (ushort)1 : (ushort)0;
            uphos(1, val);
        }

        private void CheckBox4_CheckedChanged(object sender, EventArgs e)
        {
            ushort val = checkBox4.Checked ? (ushort)1 : (ushort)0;
            uphos(0, val);
        }

        private void CheckBox1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void Thirdparty_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void Foreign_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void ListBox1_DrawItem(object sender, DrawItemEventArgs e)
        {
            e.Graphics.FillRectangle(new SolidBrush(e.BackColor), e.Bounds);
            if (e.Index >= 0)
            {
                StringFormat sStringFormat = new StringFormat();
                sStringFormat.LineAlignment = StringAlignment.Center;
                e.Graphics.DrawString(((ListBox)sender).Items[e.Index].ToString(), e.Font, new SolidBrush(e.ForeColor), e.Bounds, sStringFormat);
            }
            e.DrawFocusRectangle();
        }

        private void ListBox1_MeasureItem(object sender, MeasureItemEventArgs e)
        {
            e.ItemHeight += 12;
        }

        private void ListBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            panel1.Visible = false;
            panel2.Visible = false;
            panel3.Visible = false;
            panel5.Visible = false;
            panel6.Visible = false;
            panel7.Visible = false;
            if (this.listBox1.SelectedIndex == 0)
            {
                panel1.Visible = true;
            }
            else if (this.listBox1.SelectedIndex == 1)
            {
                panel2.Visible = true;
            }
            else if (this.listBox1.SelectedIndex == 2)
            {
                panel3.Visible = true;
            }
            else if (this.listBox1.SelectedIndex == 3)
            {
                panel5.Visible = true;
            }
            else if (this.listBox1.SelectedIndex == 4)
            {
                panel6.Visible = true;
            }
            else if (this.listBox1.SelectedIndex == 5)
            {
                panel7.Visible = true;
            }
        }

        private void SysConfig_Load(object sender, EventArgs e)
        {
            this.CHmibtn.Enabled = false;
            this.runbtn.Enabled = false;
            this.chosenbtn.Enabled = false;
            this.updatebtn.Enabled = false;
            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\startup.ini");
            if (File.Exists(file))
            {
                IniFile ini = new IniFile(file);

                string value = ini.ReadString("StartUp", "自启动");
                string opensys = ini.ReadString("StartUp", "打开系统");
                string runtype = ini.ReadString("StartUp", "运行类型");
                string info_log = ini.ReadString("Logs", "InfoLog");
                string err_log = ini.ReadString("Logs", "ErrLog");
                string hmi_log = ini.ReadString("Logs", "HmiLog");

                int Version = ini.ReadInteger("Version", "VersionType");
                string appname = ini.ReadString("Version", "AppName");
                string uname = ini.ReadString("User", "Name");
                string upwd = ini.ReadString("User", "Password");

                int dsf = ini.ReadInteger("SendData", "Thirdparty");
                int dw = ini.ReadInteger("SendData", "Foreign");
                int sdzb = ini.ReadInteger("SaveData", "ZBSaveData");
                int fi = ini.ReadInteger("StartUp", "Forceintegral");

                string sp = ini.ReadString("StartUp", "space");
                string dt = ini.ReadString("StartUp", "Datetime");
                //string unit = ini.ReadString("StartUp", "Unit");
                string sappname = ini.ReadString("StartUp", "TdName");
                string strHMISearchTime = ini.ReadString("NetWorkConfig", "搜索时间");
                switch (Version)
                {
                    case 0:
                        radioButton9.Checked = true;
                        break;
                    case 1:
                        radioButton8.Checked = true;
                        break;
                    default:
                        radioButton8.Checked = true;
                        break;
                }

                this.textBox9.Text = appname;
                ushort usHMISearchTime = 0;
                if(ushort.TryParse(strHMISearchTime,out usHMISearchTime) == true)
                {
                    this.SerachHMINumericUpDown1.Value =  usHMISearchTime;
                }
                
                if (Convert.ToInt32(value) == 1)
                {
                    this.appstartup.Checked = true;
                }
                else
                {
                    this.appstartup.Checked = false;
                }

                if (Convert.ToInt32(opensys) == 1)
                {
                    if (Convert.ToInt32(runtype) == 1)
                    {
                        this.runsingle.Checked = true;
                    }
                    if (Convert.ToInt32(runtype) == 2)
                    {
                        this.runbat.Checked = true;
                    }
                }

                if (fi == 1)
                {
                    this.checkBox2.Checked = true;
                }
                else
                {
                    this.checkBox2.Checked = false;
                }

                if (Convert.ToInt32(hmi_log) == 0)
                {
                    this.permin.Checked = false;
                }
                else
                {
                    this.permin.Checked = true;
                }

                //if (Version == 1)
                //{
                //    this.checkBox1.Checked = true;
                //}
                //else
                //{
                //    this.checkBox1.Checked = false;
                //}

                textBox1.Text = uname;
                textBox2.Text = upwd;
                textBox3.Text = upwd;

                textBox8.Text = sp;
                textBox7.Text = dt;
                textBox10.Text = sappname;

                switch (dsf)
                {
                    case 0:
                        radioButton2.Checked = true;
                        break;
                    case 1:
                        radioButton1.Checked = true;
                        break;
                    case 2:
                        radioButton3.Checked = true;
                        break;
                    default:
                        radioButton4.Checked = true;
                        break;
                }

                switch (dw)
                {
                    case 0:
                        radioButton5.Checked = true;
                        break;
                    case 1:
                        radioButton6.Checked = true;
                        break;
                    default:
                        radioButton7.Checked = true;
                        break;
                }

                checkBox3.Checked = sdzb == 1 ? true : false;
            }

            Data_Load();
            Data_Load1();
            listBox1.SelectedIndex = 0;
        }

        private void Data_Load()
        {
            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\CpdExpression.ini");
            if (File.Exists(file))
            {
                IniFile iniFile = new IniFile(file);
                int sum = iniFile.ReadInteger("CpdCount", "Count");

                for (int i = 0; i < sum; i++)
                {
                    DataGridViewRow row = new DataGridViewRow();
                    DataGridViewTextBoxCell textboxcell = new DataGridViewTextBoxCell();
                    textboxcell.Value = iniFile.ReadString("Compound" + i, "Name");//化合物名称
                    row.Cells.Add(textboxcell);
                    textboxcell.ReadOnly = false;
                    textboxcell.Style.BackColor = SystemColors.Control;

                    textboxcell = new DataGridViewTextBoxCell();
                    textboxcell.Value = iniFile.ReadString("Compound" + i, "IUnit");//单位
                    row.Cells.Add(textboxcell);
                    textboxcell.ReadOnly = false;
                    textboxcell.Style.BackColor = SystemColors.Control;

                    textboxcell = new DataGridViewTextBoxCell();
                    textboxcell.Value = iniFile.ReadString("Compound" + i, "OUnit");//单位
                    row.Cells.Add(textboxcell);
                    textboxcell.ReadOnly = false;
                    textboxcell.Style.BackColor = SystemColors.Control;

                    textboxcell = new DataGridViewTextBoxCell();
                    textboxcell.Value = iniFile.ReadString("Compound" + i, "TranUnit");//单位
                    row.Cells.Add(textboxcell);
                    textboxcell.ReadOnly = false;
                    textboxcell.Style.BackColor = SystemColors.Control;

                    textboxcell = new DataGridViewTextBoxCell();
                    textboxcell.Value = iniFile.ReadString("Compound" + i, "UExpression");//单位公式换算
                    row.Cells.Add(textboxcell);
                    textboxcell.ReadOnly = false;
                    textboxcell.Style.BackColor = SystemColors.Control;

                    textboxcell = new DataGridViewTextBoxCell();
                    textboxcell.Value = iniFile.ReadString("Compound" + i, "IExpression");//内部结果浓度公式
                    row.Cells.Add(textboxcell);
                    textboxcell.ReadOnly = false;
                    textboxcell.Style.BackColor = SystemColors.Control;

                    textboxcell = new DataGridViewTextBoxCell();
                    textboxcell.Value = iniFile.ReadString("Compound" + i, "OExpression");//外部结果浓度公式
                    row.Cells.Add(textboxcell);
                    textboxcell.ReadOnly = false;
                    textboxcell.Style.BackColor = SystemColors.Control;

                    this.dataGridView1.Rows.Add(row);
                }
            }
            else
            {
                File.Create(file);
            }

        }
        private void Data_Load1()
        {
         
            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\sys.ini");
            if (File.Exists(file))
            {
                IniFile infile = new IniFile(file);
                if (infile.KeyExists("CpdCount", "Count") == true)
                {
                    this.textBox11.Text = infile.ReadString("CpdCount", "Count");
                }
                if(infile.KeyExists("CpdCount", "Count1"))
                {
                    this.textBox12.Text = infile.ReadString("CpdCount", "Count1");
                }
                if (infile.KeyExists("CpdCount", "Count2") == true)
                {
                    this.richTextBox1.Text = infile.ReadString("CpdCount", "Count2");
                }
                if(infile.KeyExists("CpdCount", "Count3") == true)
                {
                    bIsAutoDisO2 = infile.ReadBoolean("CpdCount", "Count3");
                }
                else
                {
                    bIsAutoDisO2 = true;
                }
                if (bIsAutoDisO2 == true)
                {
                   richTextBox1.Enabled = true;
                   textBox11.Enabled = true;
                   textBox12.Enabled = true;
                   buttonA.Enabled = true;
                   radioButton10.Checked = false;
                   radioButton11.Checked = true;
                }
                else
                {
                   radioButton10.Checked = true;
                   radioButton11.Checked = false;
                   richTextBox1.Enabled = false;
                   textBox11.Enabled = false;
                   textBox12.Enabled = false;
                   buttonA.Enabled = false;

                }
            }
            else
            {
                File.Create(file);
                IniFile infile = new IniFile(file);
                radioButton10.Checked = false;
                radioButton11.Checked = true;
                infile.WriteBoolean("CpdCount", "Count3", true);
            }
        }


        private void Data_save1()
        {
            try
            {
                string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\sys.ini");
                if (File.Exists(file))
                {
                    IniFile infile = new IniFile(file);
                    infile.WriteString("CpdCount", "Count", this.textBox11.Text);
                    infile.WriteString("CpdCount", "Count1", this.textBox12.Text);
                    infile.WriteString("CpdCount", "Count2", this.richTextBox1.Text);
                    infile.WriteDouble("CpdCount", "AutoEliminationOxygenSlope",kzhi);
                    infile.WriteDouble("CpdCount", "AutoEliminationOxygenIntercept",bzhi);
                    infile.WriteBoolean("CpdCount", "Count3", bIsAutoDisO2);
                    
                }     
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }

        }
        private void Data_Save()
        {
            try
            {
                string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\CpdExpression.ini");
                if (File.Exists(file))
                {
                    IniFile iniFile = new IniFile(file);

                    iniFile.WriteInteger("CpdCount", "Count", this.dataGridView1.RowCount - 1);

                    for (int i = 0; i < this.dataGridView1.RowCount - 1; i++)
                    {
                        if (this.dataGridView1.Rows[i].Cells["Column1"].Value!=null)
                        {
                            iniFile.WriteString("Compound" + i, "Name", this.dataGridView1.Rows[i].Cells["Column1"].Value.ToString());
                        }
                        else
                        {
                            iniFile.WriteString("Compound" + i, "Name", "null");
                        }

                        if (this.dataGridView1.Rows[i].Cells["Column2"].Value != null)
                        {
                            iniFile.WriteString("Compound" + i, "IUnit", this.dataGridView1.Rows[i].Cells["Column2"].Value.ToString());
                        }
                        else
                        {
                            iniFile.WriteString("Compound" + i, "IUnit", "null");
                        }

                        if (this.dataGridView1.Rows[i].Cells["Column3"].Value != null)
                        {
                            iniFile.WriteString("Compound" + i, "OUnit", this.dataGridView1.Rows[i].Cells["Column3"].Value.ToString());
                        }
                        else
                        {
                            iniFile.WriteString("Compound" + i, "OUnit", "null");
                        }

                        if (this.dataGridView1.Rows[i].Cells["Column7"].Value != null)
                        {
                            iniFile.WriteString("Compound" + i, "TranUnit", this.dataGridView1.Rows[i].Cells["Column7"].Value.ToString());
                        }
                        else
                        {
                            iniFile.WriteString("Compound" + i, "TranUnit", "null");
                        }

                        if (this.dataGridView1.Rows[i].Cells["Column4"].Value != null)
                        {
                            iniFile.WriteString("Compound" + i, "UExpression", this.dataGridView1.Rows[i].Cells["Column4"].Value.ToString());
                        }
                        else
                        {
                            iniFile.WriteString("Compound" + i, "UExpression", "x");
                        }

                        if (this.dataGridView1.Rows[i].Cells["Column5"].Value != null)
                        {
                            iniFile.WriteString("Compound" + i, "IExpression", this.dataGridView1.Rows[i].Cells["Column5"].Value.ToString());
                        }
                        else
                        {
                            iniFile.WriteString("Compound" + i, "IExpression", "x");
                        }

                        if (this.dataGridView1.Rows[i].Cells["Column6"].Value != null)
                        {
                            iniFile.WriteString("Compound" + i, "OExpression", this.dataGridView1.Rows[i].Cells["Column6"].Value.ToString());
                        }
                        else
                        {
                            iniFile.WriteString("Compound" + i, "OExpression", "x");
                        }
                        //iniFile.WriteString("Compound" + i, "OUnit", this.dataGridView1.Rows[i].Cells["Column3"].Value.ToString());
                        //iniFile.WriteString("Compound" + i, "TranUnit", this.dataGridView1.Rows[i].Cells["Column7"].Value.ToString());
                        //iniFile.WriteString("Compound" + i, "UExpression", this.dataGridView1.Rows[i].Cells["Column4"].Value.ToString());
                        //iniFile.WriteString("Compound" + i, "IExpression", this.dataGridView1.Rows[i].Cells["Column5"].Value.ToString());
                        //iniFile.WriteString("Compound" + i, "OExpression", this.dataGridView1.Rows[i].Cells["Column6"].Value.ToString());
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }

        }

        public event UpdataHMIOpS uphops;
        private void Button1_Click(object sender, EventArgs e)
        {
            try
            {
                uphops(2);

            }
            catch
            {

            }

            try
            {
                Data_save1();
                string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\sys.ini");
                if (textBox11.Visible || textBox12.Visible || richTextBox1.Visible)
                {
                    MessageBox.Show("保存成功");
                }
                else
                {
                    MessageBox.Show("保存失败");
                }
            }
            catch (Exception ex)
            {
                Log.Error(ex.Message);
            }
            try
            {
                Data_Save();
                string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\startup.ini");
                string cpdfile = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\CpdExpression.ini");

                CKVocAnalyzer.VOCEntityConfig.Instance.readcpdexp(cpdfile);

                if (File.Exists(file))
                {
                    IniFile ini = new IniFile(file);
                    ini.WriteString("NetWorkConfig", "搜索时间",this.SerachHMINumericUpDown1.Value.ToString());
                    if (appstartup.Checked)
                    {

                        ini.WriteString("StartUp", "自启动", "1");
                        string path = Application.ExecutablePath;
                        RegistryKey rk = Registry.LocalMachine;
                        RegistryKey rk2 = rk.CreateSubKey(@"Software\Microsoft\Windows\CurrentVersion\Run");
                        rk2.SetValue("JcShutdown", path);
                        rk2.Close();
                        rk.Close();

                    }
                    else
                    {
                        ini.WriteString("StartUp", "自启动", "0");
                        string path = Application.ExecutablePath;
                        RegistryKey rk = Registry.LocalMachine;
                        RegistryKey rk2 = rk.CreateSubKey(@"Software\Microsoft\Windows\CurrentVersion\Run");
                        rk2.DeleteValue("JcShutdown", false);
                        rk2.Close();
                        rk.Close();
                    }

                    if (runbat.Checked)
                    {
                        ini.WriteString("StartUp", "打开系统", "1");
                        ini.WriteString("StartUp", "运行类型", "2");
                    }
                    else if (runsingle.Checked)
                    {
                        ini.WriteString("StartUp", "打开系统", "1");
                        ini.WriteString("StartUp", "运行类型", "1");
                    }
                    else
                    {
                        ini.WriteString("StartUp", "打开系统", "0");
                        ini.WriteString("StartUp", "运行类型", "0");
                    }

                    if (checkBox2.Checked)
                    {
                        ini.WriteString("StartUp", "Forceintegral", "1");
                    }
                    else
                    {
                        ini.WriteString("StartUp", "Forceintegral", "0");
                    }

                    if (radioButton8.Checked)
                    {
                        ini.WriteString("Version", "VersionType", "1");
                    }
                    else if (radioButton9.Checked)
                    {
                        ini.WriteString("Version", "VersionType", "0");
                    }

                    ini.WriteString("Version", "AppName", this.textBox9.Text);

                    if (this.permin.Checked)
                    {
                        ini.WriteString("Logs", "HmiLog", "1");
                        globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.hmi_log = true;
                        ini.WriteString("Logs", "InfoLog", "1");
                        globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.info_log = true;
                        ini.WriteString("Logs", "ErrLog", "1");
                        globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.error_log = true;
                    }
                    else
                    {
                        ini.WriteString("Logs", "HmiLog", "0");
                        globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.hmi_log = false;
                        ini.WriteString("Logs", "InfoLog", "0");
                        globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.info_log = false;
                        ini.WriteString("Logs", "ErrLog", "0");
                        globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.error_log = false;
                    }

                    if (radioButton1.Checked)
                    {
                        ini.WriteString("SendData", "Thirdparty", "1");//zb
                    }
                    else if (radioButton2.Checked)
                    {
                        ini.WriteString("SendData", "Thirdparty", "0");//hl
                    }
                    else if (radioButton3.Checked)
                    {
                        ini.WriteString("SendData", "Thirdparty", "2");//sp
                    }
                    else
                    {
                        ini.WriteString("SendData", "Thirdparty", "3");//无
                    }


                    if (radioButton5.Checked)
                    {
                        ini.WriteString("SendData", "Foreign", "0");//默认
                    }
                    else if (radioButton6.Checked)
                    {
                        ini.WriteString("SendData", "Foreign", "1");//环空
                    }
                    else
                    {
                        ini.WriteString("SendData", "Foreign", "2");//无
                    }

                    if (checkBox3.Checked)
                    {
                        ini.WriteString("SaveData", "ZBSaveData", "1");
                    }
                    else
                    {
                        ini.WriteString("SaveData", "ZBSaveData", "0");
                    }
                    if (string.IsNullOrEmpty(textBox8.Text))
                    {
                        ini.WriteString("StartUp", "space", "500");

                    }
                    else
                    {
                        ini.WriteString("StartUp", "space", textBox8.Text);

                    }

                    if (string.IsNullOrEmpty(textBox7.Text))
                    {
                        ini.WriteString("StartUp", "Datetime", "30");

                    }
                    else
                    {
                        ini.WriteString("StartUp", "Datetime", textBox7.Text);

                    }

                    ini.WriteString("StartUp", "TdName", textBox10.Text);

                    if (label4.Visible || label5.Visible || label6.Visible)
                    {
                        MessageBox.Show("请确保安全性");
                        return;
                    }
                    else
                    {
                        ini.WriteString("User", "Name", textBox1.Text);
                        ini.WriteString("User", "Password", textBox3.Text);
                    }

                    this.Close();
                }
                else
                {
                    MessageBox.Show("配置保存失败");
                }
            }
            catch (Exception ex)
            {
                Log.Error(ex.Message);
            }
      

        }

        private void TextBox1_TextChanged(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBox1.Text))
            {
                label4.Visible = true;
                label4.Text = "不能为空";
            }
            else
            {
                label4.Visible = false;
                label4.Text = "";
            }
        }

        private void TextBox2_TextChanged(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBox2.Text))
            {
                label5.Visible = true;
                label5.Text = "不能为空";
            }
            else
            {
                label5.Visible = false;
                label5.Text = "";
            }
        }

        private void TextBox3_TextChanged(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBox3.Text))
            {
                label6.Visible = true;
                label6.Text = "不能为空";
            }
            else if (!textBox3.Text.Equals(textBox2.Text))
            {
                label6.Visible = true;
                label6.Text = "密码不一致";
            }
            else
            {
                label6.Visible = false;
                label6.Text = "";
            }
        }
        private void vInput_Limit_MouseLeave(object sender, EventArgs e)
        {
            TextBox DeTextBox = (TextBox)sender;          
            //if(DeTextBox.Text == "")
            //{
            //    DeTextBox.Text = "0";
            //}
            ToolTip1.Show("",DeTextBox,3000);
        }
        private void vInput_Limit_TextChange(object sender, EventArgs e)
        {
            double usData;
            double dMaxInpueValue = 21;
            double dMinInputValue = 0;
            byte   bRetainBit = 2;
            TextBox DeTextBox = (TextBox)sender;
            {
            }
            if (double.TryParse(DeTextBox.Text, out usData)) //|| valve_1_start1.Text.IndexOf(".") == valve_1_start1.Text.Length)
            {
                if (usData > dMaxInpueValue)
                {
                    ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(dMaxInpueValue.ToString());
                }
                else if(usData < dMinInputValue)
                {
                    ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(dMinInputValue.ToString());
                }
                else if(DeTextBox.Text.StartsWith("0") == true && DeTextBox.Text.IndexOf(".") != 1 || (DeTextBox.Text.IndexOf(".") > -1 && DeTextBox.Text.Length - DeTextBox.Text.IndexOf(".") > (bRetainBit + 1) && DeTextBox.Text.EndsWith("0") == true))
                {
                    DeTextBox.Clear();
                    DeTextBox.AppendText(usData.ToString());
                }
                else if(DeTextBox.Text.Length == (DeTextBox.Text.IndexOf(".") + 1))
                {

                }
                else if (DeTextBox.Text.IndexOf(".") > -1 && DeTextBox.Text.Length - DeTextBox.Text.IndexOf(".") > (bRetainBit + 1))
                {
                    ToolTip1.Show($"精确小数点后{bRetainBit}位",DeTextBox,3000);
                    DeTextBox.Clear();
                    DeTextBox.AppendText(usData.ToString().Substring(0,usData.ToString().Length -1));
                }
            }
            else if(dMinInputValue < 0 && DeTextBox.Text == "-")
            {

            }
            else  if(DeTextBox.Text != "" && DeTextBox.Text.Length != 0)
            {
                string str = DeTextBox.Text;
                ToolTip1.Show($"输入值为{dMinInputValue}-{dMaxInpueValue}的区间内",DeTextBox,3000);
                DeTextBox.Clear();
                DeTextBox.AppendText(str.Substring(0,str.Length -1));
            }

        }
        private void vInput_Integer_Limit_TextChange(object sender, EventArgs e)
        {
            TextBox TempTextBox = (TextBox)sender;
            ushort usData;
            ushort usMaxValue = 100;
            ushort usMinValue = 0;
            if(TempTextBox.Text.IndexOf(".") > -1)
            {
                string  strData = TempTextBox.Text;
                ToolTip1.Show("输入值为整数",TempTextBox,3000);
                TempTextBox.Clear();
                TempTextBox.AppendText(strData.Substring(0,strData.Length -1));
            }
            if(TempTextBox.Equals(textBox4))
            {
                usMaxValue = 100;
                
            }
            else if(TempTextBox.Equals(textBox6))
            {
                usMaxValue = 200;
            }
            else if(TempTextBox.Equals(textBox5))
            {
                usMaxValue = 300;
            }
            if (ushort.TryParse(TempTextBox.Text, out usData))
            {
                if (usData > usMaxValue)
                {
                    ToolTip1.Show($"输入值为{usMinValue}-{usMaxValue}的区间内",TempTextBox,3000);
                    TempTextBox.Clear();
                    TempTextBox.AppendText(usMaxValue.ToString());
                }
                else if(usData < usMinValue)
                {
                    ToolTip1.Show($"输入值为{usMinValue}-{usMaxValue}的区间内",TempTextBox,3000);
                    TempTextBox.Clear();
                    TempTextBox.AppendText(usMinValue.ToString());
                }
                else
                {
                    TempTextBox.Clear();
                    TempTextBox.AppendText(usData.ToString());
                }
            }
	        else if(usMinValue < 0 && TempTextBox.Text == "-")
            {

            }
            else  if(TempTextBox.Text != "" && TempTextBox.Text.Length != 0)
            {
                string str = TempTextBox.Text;
                ToolTip1.Show($"输入值为{usMinValue}-{usMaxValue}的区间内",TempTextBox,3000);
                TempTextBox.Clear();
                TempTextBox.AppendText(str.Substring(0,str.Length -1));
            }
        }
        private void vTextBox_Char_Limit_TextChange(object sender, EventArgs e)
        {
            byte ucCharMaxLength = 200;
            TextBox textBox =  (TextBox) sender;
            if(textBox.TextLength > ucCharMaxLength)
            {
                 string strData = textBox.Text;
                 textBox.Clear();
                 textBox.AppendText(strData.Substring(0,strData.ToString().Length -1));
                 ToolTip1.Show($"输入的字符长度应小于{ucCharMaxLength}",textBox,3000);
            }
        }
        private void Button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void Runbat_CheckedChanged(object sender, EventArgs e)
        {
            if (runbat.Checked)
            {
                runsingle.Checked = false;
            }
        }

        private void Runsingle_CheckedChanged(object sender, EventArgs e)
        {
            if (runsingle.Checked)
            {
                runbat.Checked = false;
            }
        }

        private void CheckBox2_CheckedChanged(object sender, EventArgs e)
        {
            CKVocAnalyzer.GlobalCKV.vocAlgorithm.Forceintegral = checkBox2.Checked;
        }


        bool hmisearch = false;
        Thread addhmi;
        ManualResetEvent mre = new ManualResetEvent(false);

        bool button = false;
        Thread addhmi1;
        ManualResetEvent btn = new ManualResetEvent(false);
        
        //private void richTextBox1_MouseLeave(object sender, EventArgs e)
        //{
        //    richTextBox1.Text = buttonA.Text;
        //}
        private void buttonA_Click(object sender, EventArgs e)
        {
            
            double y1, y2, x1 = 0, x2 = 20;
            double xishu, changshu;
            string Y;
            if (double.TryParse(textBox11.Text, out y1))
            {
                if (double.TryParse(textBox12.Text, out y2))
                {
                    xishu = (y2 - y1) / (x2 - x1);
                    changshu = y2 - xishu * x2;
                    Y =  "Y="+ xishu.ToString() + "x" + " + "+  changshu.ToString();
                    richTextBox1.Text = Y;

                   kzhi = xishu;
                   bzhi = changshu;
                }
              
            }
        }

        private void radioButton10_CheckedChanged(object sender, EventArgs e)
        {

            radioButton10.ForeColor = Color.Black;
            if (radioButton10.Checked)
            {
                this.textBox11.Enabled = false;
                this.textBox12.Enabled = false;
                richTextBox1.Enabled = false;
                this.buttonA.Enabled =false;
                bIsAutoDisO2 = false;
                if(radioButton11.ForeColor == Color.Black)
                {
                   radioButton10.ForeColor = Color.Black; 
                }
            }
        }
        private void radioButton11_CheckedChanged(object sender, EventArgs e)
        {
            radioButton11.ForeColor =Color.Black;
            if (radioButton11.Checked)
            {
                this.textBox11.Enabled =true;
                this.textBox12.Enabled = true;
                this.buttonA.Enabled =true;
                bIsAutoDisO2 = true;
                richTextBox1.Enabled = true;
                if(bIsAutoDisO2 == true)
                {
                   radioButton11.ForeColor =Color.Black; 
                }

            }
        }
        private void searchHMI_Click(object sender, EventArgs e)
        {
            ArrayList DeviceList = new ArrayList();
            if (!hmisearch)
            {
                if (mre != null)
                    mre.Reset();
                addhmi = new Thread(searchhmi);
                addhmi.IsBackground = true;
                addhmi.Start();
                this.searchHMI.Text = "停止";
                hmisearch = !hmisearch;
            }
            else
            {
                this.searchHMI.Text = "搜索";
                this.hmilist.Text = "请选择...";
                mre.Set();
                hmisearch = !hmisearch;
            }
        }

        private void hmilist_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.HmiIP = this.hmilist.Text;

            this.CHmibtn.Enabled = true;

        }

        private string updateexe = null;
        private string localpath = null;
        private void CHmibtn_Click(object sender, EventArgs e)
        {
            if (HmiIP != null)
            {
                if (globaldata.m_pcbuffer.gcpcinfo.pcworkinfo.system_Statue == false)
                {
                    this.CHmibtn.Enabled = false;
                    int ret = 0;
                    FileServerClient singlesend = new FileServerClient();
                    singlesend.WtClientInit(HmiIP, HmiPort);
                    ret = singlesend.WtHMICloseRro("WtMainProc");
                    if (ret == 1)
                    {
                        MessageBox.Show("停止系统成功！");
                    }

                    singlesend.WtClientClose();
                    // this.runbtn.Enabled = true;
                    this.chosenbtn.Enabled = true;
                    this.updatebtn.Enabled = true;
                    this.runbtn.Enabled = true;
                }
                else
                {
                    MessageBox.Show("请停止系统，再关闭！");
                }


            }
        }

        private void runbtn_Click(object sender, EventArgs e)
        {
            int ret;
            if (HmiIP != null)
            {
                FileServerClient singlesend = new FileServerClient();
                singlesend.WtClientInit(HmiIP, HmiPort);
                ret = singlesend.WtHMIRunPro("GcDevice.exe", globaldata.exeremoteFolder);
                if (ret == 1)
                {
                    MessageBox.Show("开启系统成功！");
                }
                singlesend.WtClientClose();

                this.runbtn.Enabled = false;
                this.chosenbtn.Enabled = false;
                this.updatebtn.Enabled = false;
                this.CHmibtn.Enabled = true;

                this.label4.Text = "";
                this.progressBar1.Value = 0;
                this.ProName.Text = "";
            }
        }

        private void chosenbtn_Click(object sender, EventArgs e)
        {
            string file;
            OpenFileDialog fileDlg = new OpenFileDialog();
            fileDlg.Multiselect = false;
            fileDlg.InitialDirectory = globaldata.m_pcbuffer.gcpcinfo.pcfolderinfo.TmpFolder;
            fileDlg.RestoreDirectory = true;
            fileDlg.Title = "请选择方法文件";
            fileDlg.Filter = "更新程序(*.*)|*.*";
            if (fileDlg.ShowDialog() == DialogResult.OK)
            {
                file = fileDlg.FileName;
                this.updateexe = file.Substring(file.LastIndexOf("\\") + 1);
                this.localpath = file;
                this.ProName.Text = this.localpath;
                this.updatebtn.Enabled = true;

            }
        }

        private void updatebtn_Click(object sender, EventArgs e)
        {
            if (HmiIP != null)
            {
                this.CHmibtn.Enabled = false;
                this.runbtn.Enabled = false;
                this.chosenbtn.Enabled = false;
                this.updatebtn.Enabled = false;


                Thread fThread = new Thread(new ThreadStart(SleepT));
                fThread.IsBackground = true;
                fThread.Start();
            }
        }


        private bool send_ok = false;
        private void SleepT()
        {
            Thread send_Thread = new Thread(new ThreadStart(sendnewhmi));
            send_Thread.IsBackground = true;
            send_Thread.Start();

            for (int i = 0; i < 100; i++)
            {
                if (send_ok)
                {
                    SetTextMesssage(100, i.ToString() + "\r\n");
                }
                else
                {
                    Thread.Sleep(200);
                    SetTextMesssage(i, i.ToString() + "\r\n");

                    if (i == 95)
                    {
                        i--;
                    }
                }
            }
        }

        private void sendnewhmi()
        {
            int ret;
            FileServerClient singlesend = new FileServerClient();
            singlesend.WtClientInit(HmiIP, HmiPort);
            ret = singlesend.WtClientCopytoServerNoDelay(this.updateexe, this.localpath, globaldata.exeremoteFolder);

            if (ret == 1)
            {
                this.send_ok = true;
            }

            singlesend.WtClientClose();
        }

        private void searchhmi()
        {
            try
            {
                ProThread.HMISearch mysearch = new ProThread.HMISearch(null);
                int hmicount = 0;
                int i;
                mysearch.ThStart();
                while (!mre.WaitOne(500))
                {
                    hmicount = mysearch.HMICount();

                    this.Invoke(new Action(() =>
                    {
                        this.hmilist.Text = "搜索到" + hmicount + "个";
                    }));
                }

                this.Invoke(new Action(() =>
                {
                    hmilist.Items.Clear();
                    //SearchRet = globaldata.hHMIList;  
                    SearchRet = mysearch.myHMIList;
                    for (i = 0; i < hmicount; i++)
                    {
                        hmilist.Items.Add(((globaldata.DeviceInfo)(SearchRet[i])).IpAddr);
                    }
                }));
                mysearch.ThStop();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }

        }

        private void SetTextMesssage(int ipos, string vinfo)
        {
            if (this.InvokeRequired)
            {
                SetPos setpos = new SetPos(SetTextMesssage);
                this.Invoke(setpos, new object[] { ipos, vinfo });
            }
            else
            {
                this.label13.Text = ipos.ToString() + "/100";
                this.progressBar1.Value = Convert.ToInt32(ipos);

                if (ipos == 100 || send_ok)
                {
                    this.label13.Text = "传输完成";
                    this.runbtn.Enabled = true;
                    this.chosenbtn.Enabled = true;
                    this.updatebtn.Enabled = true;
                }
            }
        }

        public event StopForUpdateFirm sfupdatefirm;
        public event UpdateFirmCMD updatefirm;
        private void firmwareupdate_Click(object sender, EventArgs e)
        {
            if (HmiIP != null)
            {
                sfupdatefirm();
                this.label7.Text = "发送中...";
                Thread fThread = new Thread(new ThreadStart(FirmWareUpdate));
                fThread.IsBackground = true;
                fThread.Start();

            }
        }

        private bool updatefirm_ok = false;
        private bool sendfirm_ok = false;
        private void FirmWareUpdate()
        {
            Thread send_Thread = new Thread(new ThreadStart(sendfirmware));
            send_Thread.IsBackground = true;
            send_Thread.Start();

            for (int i = 0; i < 100; i++)
            {
                if (updatefirm_ok)
                {
                    SetTextMesssage2(100, i.ToString() + "\r\n");
                }
                else
                {
                    Thread.Sleep(500);
                    SetTextMesssage2(i, i.ToString() + "\r\n");

                    if (i == 95)
                    {
                        i--;
                    }

                }
            }
        }


        private void sendfirmware()
        {
            string firmDire = null;
            string fullfilename = null;
            bool updatestart = false;
            firmDire = globaldata.m_pcbuffer.gcpcinfo.pcfolderinfo.FwFolder;

            //try
            //{
            FileServerClient singlesend = new FileServerClient();
            DirectoryInfo theFolder = new DirectoryInfo(firmDire);
            DirectoryInfo[] dirInfo = theFolder.GetDirectories();

            singlesend.WtClientInit(HmiIP, HmiPort);
            foreach (FileInfo NextFile in theFolder.GetFiles())
            {
                fullfilename = NextFile.FullName;
                singlesend.WtClientCopytoServerNoDelay(NextFile.Name, fullfilename, globaldata.updateremoteFolder);
                Thread.Sleep(500);
            }

            sendfirm_ok = true;
            singlesend.WtClientClose();

            if (sendfirm_ok)
            {
                updatefirm();

                while (true)
                {
                    if (globaldata.m_hmibuffer.gcinfo.hmistatus == 5)
                    {

                        this.Invoke(new Action(() =>
                        {
                            this.label7.Text = "更新中...";
                        }));
                        updatestart = true;
                    }

                    if (updatestart)
                    {
                        if (globaldata.m_hmibuffer.gcinfo.hmistatus == 0)
                        {
                            this.Invoke(new Action(() =>
                            {
                                this.label7.Text = "更新完成...";
                            }));

                            updatefirm_ok = true;
                            sendfirm_ok = false;
                            break;
                        }
                    }

                    Thread.Sleep(500);
                }
            }
        }

        private void SetTextMesssage2(int ipos, string vinfo)
        {
            if (this.InvokeRequired)
            {
                SetPos setpos = new SetPos(SetTextMesssage2);
                this.Invoke(setpos, new object[] { ipos, vinfo });
            }
            else
            {
                this.label11.Text = ipos.ToString() + "/100";
                this.progressBar2.Value = Convert.ToInt32(ipos);

                if (ipos == 100)
                {
                    this.label10.Text = "更新完成...";
                }
            }
        }

        private int index = 0;
        private void dataGridView1_CellMouseUp(object sender, DataGridViewCellMouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                this.dataGridView1.Rows[e.RowIndex].Selected = true;//是否选中当前行
                index = e.RowIndex;
                this.dataGridView1.CurrentCell = this.dataGridView1.Rows[e.RowIndex].Cells[0];

                //每次选中行都刷新到datagridview中的活动单元格
                this.CmsDeletRow.Show(this.dataGridView1, e.Location);
                //指定控件（DataGridView），指定位置（鼠标指定位置）
                this.CmsDeletRow.Show(Cursor.Position);//锁定右键列表出现的位置
            }
        }


        private void TsmiDeletRow_Click(object sender, EventArgs e)
        {
            if (!this.dataGridView1.Rows[index].IsNewRow)//判断是否为新行
            {
                this.dataGridView1.Rows.RemoveAt(index);//从集合中移除指定的行
            }
        }

        private void DataGridView1_RowPostPaint(object sender, DataGridViewRowPostPaintEventArgs e)
        {
            Rectangle rectangle = new Rectangle(e.RowBounds.Location.X,
      e.RowBounds.Location.Y,
      dataGridView1.RowHeadersWidth - 4,
      e.RowBounds.Height);
            TextRenderer.DrawText(e.Graphics,
                  (e.RowIndex + 1).ToString(),
                   dataGridView1.RowHeadersDefaultCellStyle.Font,
                   rectangle,
                   dataGridView1.RowHeadersDefaultCellStyle.ForeColor,
                   TextFormatFlags.VerticalCenter | TextFormatFlags.Right);
        }

    }
}
