﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using System.Net;
using System.Net.Sockets;
using System.Diagnostics;
using System.Management;
using System.Text.RegularExpressions;
using System.Threading;
using System.Net.NetworkInformation;
using System.IO;

namespace GcDevicePc
{
    public partial class UserConfig : Form
    {

        private class SearchHMIResult
        { 
            public string _localip;
            public List<string> LinkHMIMAC = new List<string>();
        
        }
        private List<SearchHMIResult> LocalSearch   = new List<SearchHMIResult>();
        public UserConfig()
        {
            InitializeComponent();
        }

        private bool ChosenAdapter(string localip)
        {
            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\startup.ini");

            INIOperation test = new INIOperation(file);
            string Meshport = test.INIGetStringValue("NetWorkConfig", "网口", null);

            //if (string.IsNullOrEmpty(Meshport))
            //{
            //    Meshport = "本地连接";
            //}

            NetworkInterface[] nics = NetworkInterface.GetAllNetworkInterfaces();

            foreach (NetworkInterface adapter in nics)
            {
                if(adapter.Name == this.label5.Text)//if (adapter.Name == Meshport || string.IsNullOrEmpty(Meshport))
                {
                    bool Pd1 = (adapter.NetworkInterfaceType == NetworkInterfaceType.Ethernet || adapter.NetworkInterfaceType == NetworkInterfaceType.Wireless80211); //判断是否是以太网连接
                    if (Pd1)
                    {
                        {
                            IPInterfaceProperties ip = adapter.GetIPProperties();     //IP配置信息
                            UnicastIPAddressInformationCollection ipCollection = ip.UnicastAddresses;
                            foreach (UnicastIPAddressInformation ipadd in ipCollection)
                            {
                                if (ipadd.Address.AddressFamily == AddressFamily.InterNetwork)
                                {
                                    if(localip == ipadd.Address.ToString())
                                    {
                                        return true;
                                    }
                                } 
                            }
                        }
                    }
                }              
            }
            return false;
        }

        private void UserConfig_Load(object sender, EventArgs e)
        {
            //string file = globaldata.m_pcbuffer.gcpcinfo.pcfolderinfo.RunFolder + "\\startup.ini";
            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\startup.ini");

            INIOperation test = new INIOperation(file);
            string MAC = test.INIGetStringValue("NetWorkConfig", "MAC地址", null);
            string Meshport = test.INIGetStringValue("NetWorkConfig", "网口", null);

            try
            {
                bool bPortHasSearchHMI = false;
                NetworkInterface[] port = NetworkInterface.GetAllNetworkInterfaces();
                foreach (NetworkInterface adapter in port)
                {
                    bPortHasSearchHMI = false;
                    if (adapter.OperationalStatus == OperationalStatus.Up)
                    {
                        //cmbMeshport.Items.Add(adapter.Name);
                        IPInterfaceProperties ip = adapter.GetIPProperties();     //IP配置信息
                        UnicastIPAddressInformationCollection ipCollection = ip.UnicastAddresses;
                        foreach (UnicastIPAddressInformation ipadd in ipCollection)
                        {
                            if (ipadd.Address.AddressFamily == AddressFamily.InterNetwork)
                            {
                                SearchHMIResult searchHMIResult = new SearchHMIResult();
                                //this._localip.Add(ipadd.Address.ToString());//获取ip  
                                for (int i = 0; i < globaldata.CanSearchDeviceList.Count; i++)
                                { 
                                    if(globaldata.CanSearchDeviceList[i].MasterIP == ipadd.Address.ToString())
                                    {
                                        bPortHasSearchHMI = true;
                                        searchHMIResult._localip = ipadd.Address.ToString();
                                        searchHMIResult.LinkHMIMAC.Add(globaldata.CanSearchDeviceList[i].MacAddr);
                                        if(globaldata.CanSearchDeviceList[i].MacAddr == MAC)
                                        {
                                            this.label5.Text = adapter.Name;
                                        }
                                    }
                                 
                                }
                                if (bPortHasSearchHMI == true)
                                {
                                    cmbMeshport.Items.Add(adapter.Name);
                                    LocalSearch.Add(searchHMIResult);
                                }
                            }
                        }
                    }
                }



                if (String.IsNullOrEmpty(MAC))
                {
                    this.label1.Text = "目前Mac(未绑定)：";
                    //this.label3.Text = ((globaldata.DeviceInfo)globaldata.DeviceList[0]).MacAddr;

                }
                else
                {
                    this.label3.Text = MAC;
                }
            }
            catch 
            {
            }

            //if (!string.IsNullOrEmpty(Meshport))
            //{
            //    cmbMeshport.SelectedText = Meshport;
            //}

           

            if(globaldata.DeviceList.Count > 0)
            {
                //this.hmiip.Text = ((globaldata.DeviceInfo)globaldata.DeviceList[0]).IpAddr;
                //this.hmigw.Text = ((globaldata.DeviceInfo)globaldata.DeviceList[0]).Gateway;
                //this.hminm.Text = ((globaldata.DeviceInfo)globaldata.DeviceList[0]).Netmask;
                 for(int i = 0; i < globaldata.CanSearchDeviceList.Count;i++)
                 {
                    if(globaldata.CanSearchDeviceList[i].MacAddr == MAC)
                    {
                        this.hmiip.Text = globaldata.CanSearchDeviceList[i].IpAddr;
                        this.hmigw.Text = globaldata.CanSearchDeviceList[i].Gateway;
                        this.hminm.Text = globaldata.CanSearchDeviceList[i].Netmask;
                    }         
                 }
            }
        
            try
            {
                //ManagementClass mc = new ManagementClass("Win32_NetworkAdapterConfiguration");
                //ManagementObjectCollection nics = mc.GetInstances();
                //foreach (ManagementObject nic in nics)
                //{
                //    if (Convert.ToBoolean(nic["ipEnabled"]) == true)
                //    {
                //        string ip = (nic["IPAddress"] as String[])[0];//IP地址
                //        string ipsubnet = (nic["IPSubnet"] as String[])[0];//子网掩码
                //        string ipgateway = (nic["DefaultIPGateway"] as String[])[0];//默认网关
                //        if (ip != null && ChosenAdapter(ip))
                //        {
                //            this.localip.Text = ip;
                //            this.localgw.Text = ipgateway;
                //            this.localnm.Text = ipsubnet;
                //            break;
                //        }
                //        else
                //        {
                //            continue;
                //        }

                //    }
                //}

                   ManagementObjectSearcher query = new

                    ManagementObjectSearcher("SELECT * FROM Win32_NetworkAdapterConfiguration WHERE IPEnabled = 'TRUE'");

                    ManagementObjectCollection queryCollection = query.Get();

                    foreach (ManagementObject mo in queryCollection)
                    {

                        string[] addresses = (string[])mo["IPAddress"];

                        string[] subnets = (string[])mo["IPSubnet"];

                        string[] defaultgateways = (string[])mo["DefaultIPGateway"];
                        int index = 0;
                        foreach (string ipaddress in addresses)
                        {
                            
                        //Console.WriteLine(" IP Address: {0}", ipaddress)
                            if (ipaddress != null && ChosenAdapter(ipaddress))
                            {
                                this.localip.Text = ipaddress;
                                this.localnm.Text = (subnets == null) ? "":subnets[index];
                                this.localgw.Text = (defaultgateways == null) ? "0.0.0.0" : defaultgateways[index];
                                
                                break;
                            }
                            index++;
                        }
                    }
            }
            catch
            {

            }
           
        }

        private void changemac_Click(object sender, EventArgs e)
        {

            bool ret = false;

            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\startup.ini");

            INIOperation test = new INIOperation(file);

            ret = test.INIWriteValue(file, "NetWorkConfig", "MAC地址", MAComboBox1.Items[MAComboBox1.SelectedIndex].ToString());

            if (ret)
            {
                MessageBox.Show("MAC绑定修改成功,请重启软件！", "提示");
            }
            else
            {
                MessageBox.Show("MAC绑定修改失败！", "提示");
            }
        }

        private void changip_Click(object sender, EventArgs e)
        {
            UdpClient client = new UdpClient(new IPEndPoint(IPAddress.Any, 0));
            IPEndPoint endpoint =new IPEndPoint(IPAddress.Parse("255.255.255.255"), 233);;
         
            byte[] headBytes = new byte[] { 0x57, 0x54, 0x14, 0x00, 0x00, 0x00, 0x06, 0x00 };
            byte[] endBytes = new byte[] { 0x55, 0xAA };

            string myIP;
            string myMask;
            string myGW;
            myIP = this.hmiip.Text;
            myGW = this.hmigw.Text;
            myMask = this.hminm.Text;

            if (!IsIPAddress(myIP) || !IsIPAddress(myGW))
            {
                MessageBox.Show("请确认修改相关地址格式！", "提示");
                return;
            }

            int i = 0;

            //string file = globaldata.m_pcbuffer.gcpcinfo.pcfolderinfo.RunFolder + "\\startup.ini";

            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\startup.ini");


            INIOperation test = new INIOperation(file);
            string myMAC = test.INIGetStringValue("NetWorkConfig", "MAC地址", null);
            try
            {
                byte[] sMac = new byte[6];

                string[] sMAC = myMAC.Split(':');
                for (i = 0; i < 6; i++)
                    sMac[i] = Convert.ToByte(sMAC[i],16);


                byte[] update = new byte[12];

                string[] sIP = myIP.Split('.');
                for (i = 0; i < 4; i++)
                    update[i] = Convert.ToByte(sIP[i]);


                string[] sMask = myMask.Split('.');
                for (i = 0; i < 4; i++)
                    update[i + 4] = Convert.ToByte(sMask[i]);

                string[] sGW = myGW.Split('.');
                for (i = 0; i < 4; i++)
                    update[i + 8] = Convert.ToByte(sGW[i]);

                byte[] sendBytes = new Byte[headBytes.Length + sMac.Length + update.Length + endBytes.Length];
                headBytes.CopyTo(sendBytes, 0);
                sMac.CopyTo(sendBytes, headBytes.Length);
                update.CopyTo(sendBytes, headBytes.Length + sMac.Length);
                endBytes.CopyTo(sendBytes, headBytes.Length + sMac.Length + update.Length);
           
                client.Send(sendBytes, sendBytes.Length, endpoint);
                this.hminm.ReadOnly = true;
                this.hmiip.ReadOnly = true;
                this.hmigw.ReadOnly = true;
                this.hminm.Enabled = false;
                this.hmiip.Enabled = false;
                this.hmigw.Enabled = false;
                this.changip.Enabled = false;
                this.StartModifyHMIIPButton1.Enabled = true;
                MessageBox.Show("IP修改成功！", "提示");
                test.INIWriteValue(file, "NetWorkConfig", "MAC地址", myMAC);
                DialogResult result = MessageBox.Show("IP修改成功，确定重启IP软件嘛？", "提示信息", MessageBoxButtons.OKCancel);
                if (result == DialogResult.OK)
                {
                    Application.ExitThread();
                    Application.Exit();
                    Application.Restart();
                    Process.GetCurrentProcess().Kill();  
                }                                
            }
            catch (Exception)
            {
                if (myIP == null || myGW == null || myMask == null)
                {
                    MessageBox.Show("请检查IP,网关,掩码是否正确！", "提示");
                }else
                {
                    MessageBox.Show("IP修改失败！", "提示");
                }              
            }           
        }
        
        public static bool IsIPAddress(string ip)
        {
            return Regex.IsMatch(ip, @"^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$");
        }

        private void changeip()
        {
            ManagementBaseObject inPar = null;
            ManagementBaseObject outPar = null;
            //ManagementClass mc = new ManagementClass("Win32_NetworkAdapterConfiguration");
            //ManagementObjectCollection moc = mc.GetInstances();

            string myip = localip.Text;
            string mynm = localnm.Text;
            string mygw = localgw.Text;

            if (!IsIPAddress(myip) || !IsIPAddress(mygw))
            {
                MessageBox.Show("请确认修改相关地址格式！", "提示");
                return;
            }
                   ManagementObjectSearcher query = new

                    ManagementObjectSearcher("SELECT * FROM Win32_NetworkAdapterConfiguration WHERE IPEnabled = 'TRUE'");

                    ManagementObjectCollection queryCollection = query.Get();

                    foreach (ManagementObject mo in queryCollection)
                    {

                        string[] addresses = (string[])mo["IPAddress"];

                        string[] subnets = (string[])mo["IPSubnet"];

                        string[] defaultgateways = (string[])mo["DefaultIPGateway"];
                        //int index = 0;
                        foreach (string ipaddress in addresses)
                        {
                            
                        //Console.WriteLine(" IP Address: {0}", ipaddress)
                            if (ipaddress != null && ChosenAdapter(ipaddress))
                            {
                                 inPar = mo.GetMethodParameters("EnableStatic");
                                 inPar["IPAddress"] = new string[] { myip };
                                 inPar["SubnetMask"] = new string[] { mynm };
                                 outPar = mo.InvokeMethod("EnableStatic", inPar, null);
                                //设置网关地址 
                                inPar = mo.GetMethodParameters("SetGateways");
                                inPar["DefaultIPGateway"] = new string[] { mygw };
                                outPar = mo.InvokeMethod("SetGateways", inPar, null);

                                //设置DNS   
                                inPar = mo.GetMethodParameters("SetDNSServerSearchOrder");
                                inPar["DNSServerSearchOrder"] = new string[] { "8.8.8.8", "114.114.114.114" };
                                outPar = mo.InvokeMethod("SetDNSServerSearchOrder", inPar, null);
                              break;
                            }
                            //index++;
                        }
                    }
            //foreach (ManagementObject mo in moc)
            //{
            //    if (!(bool)mo["IPEnabled"])
            //    {
            //        // MessageBox.Show("已检测到网卡，但无法设置。请检查网卡优先性并确认是否已被禁用或已插网线。");
            //        continue;
            //    }

            //    //设置ip地址和子网掩码 
            //    inPar = mo.GetMethodParameters("EnableStatic");
            //    inPar["IPAddress"] = new string[] { myip };
            //    inPar["SubnetMask"] = new string[] { mynm };
            //    outPar = mo.InvokeMethod("EnableStatic", inPar, null);

            //    //设置网关地址 
            //    inPar = mo.GetMethodParameters("SetGateways");
            //    inPar["DefaultIPGateway"] = new string[] { mygw };
            //    outPar = mo.InvokeMethod("SetGateways", inPar, null);

            //    //设置DNS   
            //    inPar = mo.GetMethodParameters("SetDNSServerSearchOrder");
            //    inPar["DNSServerSearchOrder"] = new string[] { "8.8.8.8", "114.114.114.114" };
            //    outPar = mo.InvokeMethod("SetDNSServerSearchOrder", inPar, null);
            //    break;
            //}
        }

        Thread th_changeip;
        
        private void changelocal_Click(object sender, EventArgs e)
        {
            try
            {
                int count = 0; ;
                th_changeip = new Thread(changeip);
                th_changeip.IsBackground = true;
                th_changeip.Start();
                ManagementClass mc;
                while(true)
                {
                    string ip = string.Empty;
                    string ipsubnet = string.Empty;
                    string ipgateway = string.Empty; 
                    //mc = new ManagementClass("Win32_NetworkAdapterConfiguration");
                    //ManagementObjectCollection nics = mc.GetInstances();
                    //foreach (ManagementObject nic in nics)
                    //{
                    //    if (Convert.ToBoolean(nic["ipEnabled"]) == true)
                    //    {
                    //        ip = (nic["IPAddress"] as String[])[0];//IP地址
                    //        ipsubnet = (nic["IPSubnet"] as String[])[0];//子网掩码
                    //        ipgateway = (nic["DefaultIPGateway"] as String[])[0];//默认网关             
                    //    }
                    //}
                   ManagementObjectSearcher query = new

                    ManagementObjectSearcher("SELECT * FROM Win32_NetworkAdapterConfiguration WHERE IPEnabled = 'TRUE'");

                    ManagementObjectCollection queryCollection = query.Get();

                    foreach (ManagementObject mo in queryCollection)
                    {

                        string[] addresses = (string[])mo["IPAddress"];

                        string[] subnets = (string[])mo["IPSubnet"];

                        string[] defaultgateways = (string[])mo["DefaultIPGateway"];
                        int index = 0;
                        foreach (string ipaddress in addresses)
                        {
                            
                        //Console.WriteLine(" IP Address: {0}", ipaddress)
                            if (ipaddress != null && ChosenAdapter(ipaddress))
                            {
                                ip = ipaddress;
                                ipsubnet = (subnets == null) ? "":subnets[index];
                                ipgateway = (defaultgateways == null) ? "0.0.0.0" : defaultgateways[index];
                                
                                break;
                            }
                            index++;
                        }
                    }
                    if(this.localip.Text == ip && this.localgw.Text == ipgateway && this.localnm.Text == ipsubnet)
                    {
                        break;   
                    }
                    Thread.Sleep(200);
                    count++;
                    if (count == 20)
                        break;
                }
              
                if(count == 10)
                {
                    MessageBox.Show("本机IP修改失败！", "提示"); 
                }
                else
                {
                    this.localip.ReadOnly = true;
                    this.localnm.ReadOnly = true;
                    this.localgw.ReadOnly = true;
                    this.localip.Enabled = false;
                    this.localnm.Enabled = false;
                    this.localgw.Enabled = false;

                    this.changelocal.Enabled              = false;
                    this.StartModifyLocalIPButton.Enabled = true;
                    DialogResult result = MessageBox.Show("修改完成，是否重启PC软件？", "提示信息", MessageBoxButtons.OKCancel);
                    if (result == DialogResult.OK)
                    {
                        Application.ExitThread();
                        Application.Exit();
                        Application.Restart();
                        Process.GetCurrentProcess().Kill();
                    }                             
                }
            }
            catch (Exception)
            {
                MessageBox.Show("本机IP修改失败！", "提示");               
            }
        }

        private void cmbMeshport_SelectedIndexChanged(object sender, EventArgs e)
        {

            try
            {
                MAComboBox1.Items.Clear();
                for(int i = 0; i < LocalSearch[cmbMeshport.SelectedIndex].LinkHMIMAC.Count;i++)
                {
                   MAComboBox1.Items.Add(LocalSearch[cmbMeshport.SelectedIndex].LinkHMIMAC[i]);
                }

            }
            catch(Exception ex)
            {
                Console.WriteLine(ex);
            }
        }

        private void MAComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                if(MAComboBox1.Items[MAComboBox1.SelectedIndex].ToString() == this.label3.Text && this.label3.Text != null && this.label3.Text != "00:00:00:00:00:00")
                {
                    UnBindButton1.Enabled = true;
                    changemac.Enabled     = false;
                }
                else
                {
                    UnBindButton1.Enabled = false;
                    changemac.Enabled     = true;
                }
            }
            catch(Exception ex)
            {
                Console.WriteLine(ex);
            }
        }

        private void StartModifyHMIIPButton1_Click(object sender, EventArgs e)
        {
            this.hminm.ReadOnly = false;
            this.hmiip.ReadOnly = false;
            this.hmigw.ReadOnly = false;

            this.hminm.Enabled = true;
            this.hmiip.Enabled = true;
            this.hmigw.Enabled = true;

            this.changip.Enabled = true;
            this.StartModifyHMIIPButton1.Enabled = false;
            MessageBox.Show("此为重要通讯参数，请确保数据输入准确性！！！", "提示");
        }

        private void StartModifyLocalIPButton_Click(object sender, EventArgs e)
        {
            this.localip.ReadOnly = false;
            this.localnm.ReadOnly = false;
            this.localgw.ReadOnly = false;
            this.localip.Enabled = true;
            this.localnm.Enabled = true;
            this.localgw.Enabled = true;

            this.changelocal.Enabled              = true;
            this.StartModifyLocalIPButton.Enabled = false;
            MessageBox.Show("此为重要通讯参数，请确保数据输入准确性！！！", "提示");
        }

        private void UnBindButton1_Click(object sender, EventArgs e)
        {

            bool ret = false;

            string file = Path.Combine(Path.GetDirectoryName(System.Windows.Forms.Application.StartupPath), "GC_Config\\GC_Set\\启动参数\\startup.ini");

            INIOperation test = new INIOperation(file);

            ret = test.INIWriteValue(file, "NetWorkConfig", "MAC地址", "");

            if (ret)
            {
                MessageBox.Show("MAC解绑成功！", "提示");
            }
            else
            {
                MessageBox.Show("MAC解绑失败！", "提示");
            }
        }
    }
}
